/* which.cmd

   Simple equivalent to the un*x which(1) util:
   it detects which external(!) executable will be found
   if a command is specified without a complete path.


   Initial version: 19990429
   Current version: 19990623

   Alexander Mai
   st002279@hrzpub.tu-darmstadt.de
   amai@lesstif.org
   http://www.tu-darmstadt.de/~st002279/os2/
*/


parse arg param

if (param = "") | (param = "-?") then
  do
  say "Syntax: which  command"
  exit
  end
if ChkRexxUtil() <> 0 then
  do
  say "RexxUtil is not installed!"
  exit
  end
rc=IsInPath(param)  /* Subroutine to do the real work */
if rc <> "" then
  say rc
else
  say param" not in path"
exit


IsInPath: PROCEDURE
/* slightly pathological subroutine to detect an executable
   in PATH */
parse Arg command
rs=""

/* the following should exactly match cmd.exe's behaviour.
   I do not know where this is documented if at all -
   I just used trial&error ... */
if Strip(command) <> "" then
   do
   rs=SysSearchPath("PATH", command)
   if rs = "" then
      do
      rs=SysSearchPath("PATH", command".com")
      if rs = "" then
         do
         rs=SysSearchPath("PATH", command".exe")
         if rs = "" then
            do
            rs=SysSearchPath("PATH", command".cmd")
            if rs = "" then
               do
               rs=SysSearchPath("PATH", command".bat")
               end
            end
         end
      end
   end
return rs 
/* end IsInPath() */


ChkRexxUtil: Procedure
/* Returns 0 if RexxUtil can/has been loaded properly, 1 else */

if RxFuncQuery('SysLoadFuncs') = 1 then
   do
   if RxFuncAdd('SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs') <> 0 then
      return 1
   else
      do
      call SysLoadFuncs
      return 0
      end
   end
else
   do
   call SysLoadFuncs
   return 0
   end
/* end ChkRexxUtil() */
